pushd %~dp0
@ECHO OFF
SET  APP_NAME= Intel RST Driver
SET  SILENT_CMD= pnputil -a "%~dp0iRST\*.inf" -i 
SET  RETURN_CODE=
SET  APP_LOG=C:\Windows\logs\iRST.log

IF NOT EXIST C:\Windows\logs\ MD C:\Windows\logs\
REM ===================================
ECHO [%TIME%] == The Installation of %APP_NAME%== >> %APP_LOG%

:ChkOEM1
for /f %%i in ( 'dir /b C:\Windows\INF\oem*.inf' ) do call :unins1 %%i
goto :ChkREG1

:unins1
set oemstr=%1
REM find /i "CatalogFile=iaStorAC.cat" C:\Windows\INF\%oemstr%
REM if %errorlevel%==0 (pnputil /delete-driver %oemstr% /force) & timeout /t 5 /nobreak >> %APP_LOG%
find /i "CatalogFile=iaAHCIC.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 (pnputil /delete-driver %oemstr% /force) & timeout /t 5 /nobreak >> %APP_LOG%
goto :eof

:ChkREG1
:: Check Registry first
reg query "HKLM\SYSTEM\ControlSet001\Services\iaStorAC\Parameters\Device\NvmeApstEnabled" >> %APP_LOG%
if /i not "%errorlevel%"==0 goto :Ins_Drv
reg delete "HKLM\SYSTEM\ControlSet001\Services\iaStorAC\Parameters\Device\NvmeApstEnabled" /f >> %APP_LOG%
timeout /t 5 /nobreak

:Ins_Drv
REM Run Silent Install Command:
CALL %SILENT_CMD% >> %APP_LOG%
ECHO Errorlevel=%Errorlevel% >> %APP_LOG%

:ChkOEM2	
for /f %%i in ( 'dir /b C:\Windows\INF\oem*.inf' ) do call :unins2 %%i


:unins2
set oemstr=%1
find /i "CatalogFile=iaStorAC.cat" C:\Windows\INF\%oemstr%
if %errorlevel%==0 (pnputil /delete-driver %oemstr% /force) & timeout /t 5 /nobreak >> %APP_LOG%
goto :eof



REM Filter Acceptable Return Codes:
SET RETURN_CODE=%errorlevel%
FOR %%i in (0,3010) DO (
	IF %Errorlevel% == %%~i set RETURN_CODE=0
)
:END
popd
exit /b %RETURN_CODE%